local mod = ...


-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/Tree1RootPart", "PREFAB_TREEFOLK_TREE1ROOT")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/Tree1TilingPart", "PREFAB_TREEFOLK_TREE1TILING")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/Tree1EndPart", "PREFAB_TREEFOLK_TREE1END")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/Tree2EndPart", "PREFAB_TREEFOLK_TREE2END")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/Tree3EndPart", "PREFAB_TREEFOLK_TREE3END")

mod:registerAssetId("models/TreeFolk1.fbx/Prefab/Water1Part", "PREFAB_TREEFOLK_WATER1")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/Sacred1Part", "PREFAB_TREEFOLK_SACRED1")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/Market1Part", "PREFAB_TREEFOLK_MARKET1")

mod:registerAssetId("models/TreeFolk1.fbx/Prefab/TreeHouse1EndPart", "PREFAB_TREEFOLK_TREEHOUSE1END")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/TreeHouse1RootPart", "PREFAB_TREEFOLK_TREEHOUSE1ROOT")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/TreeHouse1TilingPart", "PREFAB_TREEFOLK_TREEHOUSE1TILING")

mod:registerAssetId("models/TreeFolk1.fbx/Prefab/DruidFemale", "PREFAB_TREEFOLK_DRUIDFEMALE")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/DruidMale", "PREFAB_TREEFOLK_DRUIDMALE")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/DruidStaff", "PREFAB_TREEFOLK_DRUIDSTAFF")

mod:registerAssetId("models/TreeFolk2.fbx/Prefab/Stair1Part", "PREFAB_TREEFOLK_STAIR1")

mod:registerAssetId("models/TreeFolk3.fbx/Prefab/Bridge1Part", "PREFAB_TREEFOLK_BRIDGE1")

mod:registerAssetId("models/TreeFolk4.fbx/Prefab/Platform1EndPart", "PREFAB_TREEFOLK_PLATFORM1END")

mod:registerAssetId("models/TreeFolk5.fbx/Prefab/Snare1Part", "PREFAB_TREEFOLK_SNARE1")

mod:registerAssetId("models/TreeFolk6.fbx/Prefab/Mushroom1Part", "PREFAB_TREEFOLK_MUSHROOM_001")
mod:registerAssetId("models/TreeFolk6.fbx/Prefab/Hut1Part", "PREFAB_TREEFOLK_MUSHROOMHUT1")
mod:registerAssetId("models/TreeFolk6.fbx/Prefab/Hut1Part", "PREFAB_TREEFOLK_MUSHROOMHUT1")
mod:registerAssetId("models/TreeFolk6.fbx/Prefab/Hut1Part", "PREFAB_TREEFOLK_MUSHROOMHUT1")
mod:registerAssetId("models/TreeFolk6.fbx/Prefab/HatPart1", "PREFAB_HAT_FARMER1")
mod:registerAssetId("models/TreeFolk6.fbx/Prefab/HatPart2", "PREFAB_HAT_FARMER2")

mod:registerAssetId("models/TreeFolk7.fbx/Prefab/Forester1EndPart", "PREFAB_TREEFOLK_FORESTER1END")

mod:registerAssetId("models/TreeFolk8.fbx/Prefab/Nest1EndPart", "PREFAB_TREEFOLK_NEST1END")



-- Material (transparency) -------------------------------------------------------------------------------------
mod:registerAssetId("models/TreeFolk1.fbx/Materials/Material.Tree1", "MATERIAL_TREEFOLK_TREE1")
mod:registerAssetId("models/TreeFolk1.fbx/Materials/Material.Tree2", "MATERIAL_TREEFOLK_TREE2")
mod:registerAssetId("models/TreeFolk1.fbx/Materials/Material.Tree3", "MATERIAL_TREEFOLK_TREE3")
mod:registerAssetId("models/TreeFolk5.fbx/Materials/Material.Tree3", "MATERIAL_TREEFOLK_TREE4")
mod:registerAssetId("models/TreeFolk5.fbx/Materials/Material.Net1", "MATERIAL_TREEFOLK_NET1")
mod:registerAssetId("models/TreeFolk8.fbx/Materials/Material.Tree2", "MATERIAL_TREEFOLK_TREE5")

mod:override({
    Id = "MATERIAL_TREEFOLK_TREE1",
    HasAlphaTest = true
})

mod:override({
    Id = "MATERIAL_TREEFOLK_TREE2",
    HasAlphaTest = true
})

mod:override({
    Id = "MATERIAL_TREEFOLK_TREE3",
    HasAlphaTest = true
})

mod:override({
    Id = "MATERIAL_TREEFOLK_TREE4",
    HasAlphaTest = true
})

mod:override({
    Id = "MATERIAL_TREEFOLK_NET1",
    HasAlphaTest = true
})

mod:override({
    Id = "MATERIAL_TREEFOLK_TREE5",
    HasAlphaTest = true
})



-- Comp Building Part -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/TreeFolk2.fbx/Prefab/Stair1Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "DOOR"
})

-- mod:registerPrefabComponent("models/TreeFolk3.fbx/Prefab/Bridge1Part", {
-- 	DataType = "COMP_BUILDING_PART",
-- 	BuildingPartType = "MINOR"
-- })

mod:registerPrefabComponent("models/TreeFolk5.fbx/Prefab/Snare1Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR"
})

mod:registerEnumValue("BUILDING_PART_TYPE", "MUSHROOM")
mod:registerEnumValue("ATTACH_NODE_TYPE", "MUSHROOM")

mod:registerPrefabComponent("models/TreeFolk6.fbx/Prefab/Mushroom1Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MUSHROOM"
})



-- Attach nodes -------------------------------------------------------------------------------------
for i = 1, 1, 1 do
    mod:registerPrefabComponent("models/TreeFolk6.fbx/Prefab/Hut1Part/Attach_Mushroom." .. string.sub("000" .. i, -3), { DataType = "COMP_BUILDING_ATTACH_NODE", AttachNodeTypeList = { "MUSHROOM" } })
end



-- Platform  -------------------------------------------------------------------------------------
mod:configurePrefabFlagList("models/TreeFolk1.fbx/Prefab/TreeHouse1EndPart", { "PLATFORM" })
mod:configurePrefabFlagList("models/TreeFolk2.fbx/Prefab/Stair1Part", { "PLATFORM" })
mod:configurePrefabFlagList("models/TreeFolk3.fbx/Prefab/Bridge1Part", { "PLATFORM" })
mod:configurePrefabFlagList("models/TreeFolk4.fbx/Prefab/Platform1EndPart", { "PLATFORM" })
mod:configurePrefabFlagList("models/TreeFolk5.fbx/Prefab/Snare1Part", { "PLATFORM" })
mod:configurePrefabFlagList("models/TreeFolk6.fbx/Prefab/Hut1Part", { "PLATFORM" })
mod:configurePrefabFlagList("models/TreeFolk7.fbx/Prefab/Forester1EndPart", { "PLATFORM" })
mod:configurePrefabFlagList("models/TreeFolk8.fbx/Prefab/Nest1EndPart", { "PLATFORM" })



-- Grounding
mod:registerPrefabComponent("models/TreeFolk7.fbx/Prefab/Forester1EndPart/Log.001", {DataType = "COMP_GROUNDED"})

for i=1, 20, 1 do
	mod:registerPrefabComponent("models/TreeFolk6.fbx/Prefab/Hut1Part/Attach_Mushroom." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end



-- Paths: Market -------------------------------------------------------------------------------------
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/Market1Part/PATH_R_1", "PATH_TREEFOLK_MARKET1_SELL1")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/Market1Part/PATH_S_1", "PATH_TREEFOLK_MARKET1_SELL2")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/Market1Part/PATH_RS_2", "PATH_TREEFOLK_MARKET1_SELL3")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/Market1Part/PATH_T_1", "PATH_TREEFOLK_MARKET1_BUY1")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/Market1Part/PATH_U_1", "PATH_TREEFOLK_MARKET1_BUY2")
mod:registerAssetId("models/TreeFolk1.fbx/Prefab/Market1Part/PATH_V_1", "PATH_TREEFOLK_MARKET1_BUY3")

mod:registerPrefabComponent("models/TreeFolk1.fbx/Prefab/Market1Part", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "PATH_TREEFOLK_MARKET1_SELL1", "PATH_TREEFOLK_MARKET1_SELL3" }
        },
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "PATH_TREEFOLK_MARKET1_SELL2", "PATH_TREEFOLK_MARKET1_SELL3" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_TREEFOLK_MARKET1_BUY1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_TREEFOLK_MARKET1_BUY2" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_TREEFOLK_MARKET1_BUY3" }
        },
    }
})



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/TreeFolk1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/TreeFolk2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/TreeFolk3.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/TreeFolk4.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/TreeFolk5.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/TreeFolk6.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/TreeFolk7.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/TreeFolk8.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Resource container -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/TreeFolk6.fbx/Prefab/Mushroom1Part", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_MUSHROOM",
    IsReplenishable = true,
    ReplenishDurationInDays = 7,
    ReplenishQuantity = 2,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 2, -- maximum container stock
    Radius = 1.0, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false
})



-- Job: Druid -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_TREEFOLK_DRUID",
	JobName = "JOB_TREEFOLK_DRUID_NAME",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 30.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        RightHandObject = {
			DataType = "HAND_OBJECT",
            Model = "PREFAB_TREEFOLK_DRUIDSTAFF"
        },
        FemaleHatList = {
            "PREFAB_TREEFOLK_DRUIDFEMALE",
        }, 
        MaleHatList = {
            "PREFAB_TREEFOLK_DRUIDMALE",
        }, 
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_TREEFOLK_DRUID"
    }
})



-- Job: Forager -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_TREEFOLK_FORAGER",
	JobName = "JOB_TREEFOLK_FORAGER_NAME",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_GATHER",
    ProductionDelay = 30.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        FemaleHatList = {
            "PREFAB_HAT_FARMER1",
        }, 
        MaleHatList = {
            "PREFAB_HAT_FARMER2",
        }, 
		WalkAnimation = "WALKING",
		IdleAnimation = "GATHER"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_TREEFOLK_FORAGER"
    }
})



-- Job: Hunter -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_TREEFOLK_WILDFOWL",
	JobName = "JOB_TREEFOLK_WILDFOWL_NAME",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 30.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        LeftHandObject = {
            Model = "PREFAB_TOOL_FARMER_SEED_BAG", 
            WorkAttachName = "SeedBag_Anchor", 
            WalkAttachName = "SeedBag_Anchor"
        },
		WalkAnimation = "WALKING",
		IdleAnimation = "MARKET_TENDER"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_TREEFOLK_WILDFOWL"
    }
})



-- Building Function: Wildfowl snare -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_TREEFOLK_SNARE",
    Name = "BUILDING_PART_TREEFOLK_SNARE_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_TREEFOLK_WILDFOWL", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
    ResourceProduced = {
		{ Resource = "RESOURCE_POULTRY", Quantity = 1 },
	}
})



-- Building: Tree Folk -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_TREEFOLK",
	Name = "BUILDING_TREEFOLK_NAME",
	Description = "BUILDING_TREEFOLK_DESC",
	BuildingType = "MONUMENT",
	AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_TREEFOLK1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TREEFOLK_TREE1",
				"BUILDING_PART_TREEFOLK_TREE2",
				"BUILDING_PART_TREEFOLK_TREE3",
				"BUILDING_PART_TREEFOLK_TREEHOUSE1",
				"BUILDING_PART_TREEFOLK_PLATFORM1",
				"BUILDING_PART_TREEFOLK_STAIR1",
				-- "BUILDING_PART_TREEFOLK_BRIDGE1",
			}
		},
		{
			Name = "BUILDING_SET_TREEFOLK2_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TREEFOLK_WATER1",
				"BUILDING_PART_TREEFOLK_FORESTER1",
				"BUILDING_PART_TREEFOLK_SACRED1",
				"BUILDING_PART_TREEFOLK_SNARE1",
				"BUILDING_PART_TREEFOLK_NEST1",
				"BUILDING_PART_TREEFOLK_MUSHROOM1",
				"BUILDING_PART_TREEFOLK_MARKET1",
			}
		},
    },
	-- VillagerRequired = { Status = "SERF", Quantity = 10 },
	IsEditable = true,
    IsClearTrees = false,
})



-- Building Part: Tree 1 -------------------------------------------------------------------------------------

-- End
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_TREE1END",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_TREE1END"
	},
	-- ConstructionVisual = "PREFAB_TREEFOLK_TREEHOUSE1END_CONSTR",
	Cost = {
        -- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 4 },
        --     { Resource = "PLANK", Quantity = 4 },
        --     { Resource = "STONE", Quantity = 4 },
		-- }
	}
})

-- Tiling
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_TREE1TILING",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_TREE1TILING"
	},
	Cost = {
	}
})

-- Final
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_TREE1",
	Name = "BUILDING_PART_TREEFOLK_TREE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_TREEFOLK_TREE1ROOT",
		EndPart = "BUILDING_PART_TREEFOLK_TREE1END",
		FillerList = {
		    "BUILDING_PART_TREEFOLK_TREE1TILING",
    	},
		BasementFillerList = {
       	},
		MinimumScale = 0,
		IsVertical = true
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 2.8, {0, 0}, 16 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	},
	Cost = {
		BuildRightTaxes = {	{ Resource = "WOOD", Quantity = 10 } },
        -- UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
        -- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 10 },
		-- }
	}
})



-- Building Part: Tree 2 -------------------------------------------------------------------------------------

-- End
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_TREE2END",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_TREE2END"
	},
	-- ConstructionVisual = "PREFAB_TREEFOLK_TREEHOUSE1END_CONSTR",
	Cost = {
        -- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 4 },
        --     { Resource = "PLANK", Quantity = 4 },
        --     { Resource = "STONE", Quantity = 4 },
		-- }
	}
})

-- Final
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_TREE2",
	Name = "BUILDING_PART_TREEFOLK_TREE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_TREEFOLK_TREE1ROOT",
		EndPart = "BUILDING_PART_TREEFOLK_TREE2END",
		FillerList = {
		    "BUILDING_PART_TREEFOLK_TREE1TILING",
    	},
		BasementFillerList = {
       	},
		MinimumScale = 0,
		IsVertical = true
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 2.8, {0, 0}, 16 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	},
	Cost = {
		BuildRightTaxes = {	{ Resource = "WOOD", Quantity = 10 } },
        -- UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
        -- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 10 },
		-- }
	}
})



-- Building Part: Tree 3 -------------------------------------------------------------------------------------

-- End
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_TREE3END",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_TREE3END"
	},
	-- ConstructionVisual = "PREFAB_TREEFOLK_TREEHOUSE1END_CONSTR",
	Cost = {
        -- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 4 },
        --     { Resource = "PLANK", Quantity = 4 },
        --     { Resource = "STONE", Quantity = 4 },
		-- }
	}
})

-- Final
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_TREE3",
	Name = "BUILDING_PART_TREEFOLK_TREE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_TREEFOLK_TREE1ROOT",
		EndPart = "BUILDING_PART_TREEFOLK_TREE3END",
		FillerList = {
		    "BUILDING_PART_TREEFOLK_TREE1TILING",
    	},
		BasementFillerList = {
       	},
		MinimumScale = 0,
		IsVertical = true
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 2.8, {0, 0}, 16 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	},
	Cost = {
		BuildRightTaxes = {	{ Resource = "WOOD", Quantity = 10 } },
        -- UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
        -- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 10 },
		-- }
	}
})



-- Building Part: Tree House 1 -------------------------------------------------------------------------------------

-- End
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_TREEHOUSE1END",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_TREEHOUSE1END"
	},
	-- ConstructionVisual = "PREFAB_TREEFOLK_TREEHOUSE1END_CONSTR",
	Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 12 },
		}
	}
})

-- Tiling
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_TREEHOUSE1TILING",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_TREEHOUSE1TILING"
	},
	Cost = {
	}
})

-- Final
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_TREEHOUSE1",
	Name = "BUILDING_PART_TREEFOLK_TREEHOUSE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_TREEFOLK_TREEHOUSE1ROOT",
		EndPart = "BUILDING_PART_TREEFOLK_TREEHOUSE1END",
		FillerList = {
		    "BUILDING_PART_TREEFOLK_TREEHOUSE1TILING",
    	},
		BasementFillerList = {
       	},
		MinimumScale = 0,
		IsVertical = true
	},
    Capacity = 4,
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 2.6, {0, 0}, 16 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_TREEFOLK_TREEHOUSE1",
	Cost = {
	}
})

-- House Setup -------------------------------------------------------------------------------------------
mod:register({
    DataType = "HOUSE_SETUP",
    Id = "HOUSE_SETUP_TREEFOLK_TREEHOUSE1",
    HouseStatusList = {
        {
            DataType = "HOUSE_STATUS",
            RequiredDesirability = DESIRABILITY_LEVEL.LOW,
            ResourceGenerated = "HOUSING_LEVEL_1",
            HouseDensityPartList = { 
                "BUILDING_PART_TREEFOLK_TREEHOUSE1",
            }
        },
    }
})

mod:register({
    DataType = "BUILDING_FUNCTION_HOUSE",
    Id = "BUILDING_FUNCTION_TREEFOLK_TREEHOUSE1",
    RelatedZone = "RESIDENTIAL",
    RelatedDesirability = "DESIRABILITY_RESIDENTIAL",
    AssetHouseSetup = "HOUSE_SETUP_TREEFOLK_TREEHOUSE1"
})



-- Building Part: Platform 1 -------------------------------------------------------------------------------------

-- End
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_PLATFORM1END",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_PLATFORM1END"
	},
	-- ConstructionVisual = "PREFAB_TREEFOLK_TREEHOUSE1END_CONSTR",
	Cost = {
        -- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 2 },
		-- }
	}
})

-- Final
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_PLATFORM1",
	Name = "BUILDING_PART_TREEFOLK_PLATFORM_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_TREEFOLK_TREE1ROOT",
		EndPart = "BUILDING_PART_TREEFOLK_PLATFORM1END",
		FillerList = {
		    "BUILDING_PART_TREEFOLK_TREE1TILING",
    	},
		BasementFillerList = {
       	},
		MinimumScale = 0,
		IsVertical = true
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 2.6, {0, 0}, 16 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	},
	Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
		}
	}
})



-- Building Part: Stair 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_STAIR1",
	Name = "BUILDING_PART_TREEFOLK_STAIR_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_STAIR1"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {5.0, 0.9}, {-0.5, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		},
	},
	Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
		}
	}
})



-- Building Part: Bridge 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_BRIDGE1",
	Name = "BUILDING_PART_TREEFOLK_BRIDGE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_BRIDGE1"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {14.0, 0.9}, {0.0, 0} ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
            { 
                Polygon = polygon.createRectangle( {2.0, 0.9}, {-5.0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
            { 
                Polygon = polygon.createRectangle( {2.0, 0.9}, {5.0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		},
	},
	Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
		}
	}
})



-- Building Part: Water 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_WATER1",
	Name = "BUILDING_PART_TREEFOLK_WATER_NAME", 
    AssetBuildingFunction = "BUILDING_FUNCTION_WELL",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_WATER1"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = { 
                    {-2.3, 0},
                    {-2, 1},
                    {-1, 1.6},
                    {0, 1.8},
                    {1, 1.3},
                    {2, 0.4},
                    {2.2, -0.4},
                    {2.1, -1.3},
                    {1.6, -1.7},
                    {0.6, -1.9},
                    {-0.8, -1.6},
                    {-2, -1},
                },
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
            { 
                Polygon = polygon.createCircle( 1.5, {0.0, 0}, 10 ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
			},
		},
	},
	Cost = {
        BuildRightTaxes = {	{ Resource = "WOOD", Quantity = 10 } }
	}
})



-- Building Part: Forester / Woodcutter combo 1 -------------------------------------------------------------------------------------

-- End
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_FORESTER1END",
    Name = "BUILDING_PART_TREEFOLK_FORESTER_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_FORESTER1END"
	},
	-- ConstructionVisual = "PREFAB_TREEFOLK_TREEHOUSE1END_CONSTR",
	Cost = {
        -- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 4 },
        --     { Resource = "PLANK", Quantity = 4 },
        --     { Resource = "STONE", Quantity = 4 },
		-- }
	},
    AssetBuildingFunction = "BUILDING_FUNCTION_WOODCUTTER",
})

-- Final
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_FORESTER1",
	Name = "BUILDING_PART_TREEFOLK_FORESTER_NAME", 
    Description = "BUILDING_PART_TREEFOLK_FORESTER_DESC",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_TREEFOLK_TREE1ROOT",
		EndPart = "BUILDING_PART_TREEFOLK_FORESTER1END",
		FillerList = {
		    "BUILDING_PART_TREEFOLK_TREE1TILING",
    	},
		BasementFillerList = {
       	},
		MinimumScale = 0,
		IsVertical = true
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = {
                    {-1.7, -1.5},
                    {-2.5, -3.1},
                    {-1.0, -4},
                    {-.2, -2.4},

                    {0.2, -2.4},
                    {1, -3.4},
                    {2, -3.4},
                    {2.3, -3},
                    {2.3, -2.2},
                    {1.7, 1.5},

                    {2, -0.8},
                    {4.1, -0.8},
                    {4.1, 0.8},
                    {2, 0.8},
 
                    {1.5, 1.5},
                    {1, 1.8},
                    {0, 2.1},

                    {-.5, 2},
                    {-1.7, 3.8},
                    {-3, 2.8},
                    {-1.8, 1.1},

                    {-2, 1},
                    {-2.2, 0},
                    {-2, -1},
                },
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		},
	},
    AssetBuildingFunction = "BUILDING_FUNCTION_FORESTER",
	Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 6 },
            { Resource = "TOOL", Quantity = 3 },
		}
	}
})



-- Building Function: Sacred Tree -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_TREEFOLK_SACRED",
    Name = "BUILDING_PART_TREEFOLK_SACRED_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_TREEFOLK_DRUID", 
        Behavior = "BEHAVIOR_WORK"
	},
	TypeList = { "RESOURCE_TYPE_PAGANISM" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 10,
  	ResourceProduced = {
		{ Resource = "RESOURCE_PAGANISM", Quantity = 1 },
	}
})



-- Building Part: Sacred Tree 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_SACRED1",
	Name = "BUILDING_PART_TREEFOLK_SACRED_NAME", 
    AssetBuildingFunction = "BUILDING_FUNCTION_TREEFOLK_SACRED",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_SACRED1"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 3.7, {0.0, 0.0}, 16 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		},
	},
	Cost = {
        BuildRightTaxes = {	{ Resource = "WOOD", Quantity = 10 } }
	}
})



-- Building Part: Snare 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_SNARE1",
	Name = "BUILDING_PART_TREEFOLK_SNARE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_SNARE1"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 1.5, {0.0, 0}, 12 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		},
	},
    IsOnlyAttached = true,
    AssetBuildingFunction = "BUILDING_FUNCTION_TREEFOLK_SNARE",
	Cost = {
        BuildRightTaxes = {	{ Resource = "WOOD", Quantity = 6 } }
	}
})



-- Building Function: Forager -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_TREEFOLK_MUSHROOM",
    Name = "BUILDING_PART_TREEFOLK_MUSHROOM_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_TREEFOLK_FORAGER", 
        Behavior = "BEHAVIOR_GATHER"
	},
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_MUSHROOM", Quantity = 1 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_MUSHROOM", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_MUSHROOM", Quantity = 1 },
	}
})



-- Building Part: individual mushrooms -------------------------------------------------------------------------------------
for i=1, 1, 1 do

    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_TREEFOLK_MUSHROOM_" .. string.sub("000" .. i, -3),
        Name = "BUILDING_PART_TREEFOLK_MUSHROOM_" .. string.sub("000" .. i, -3) .. "_NAME", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_TREEFOLK_MUSHROOM_" .. string.sub("000" .. i, -3)
        }
    })

end



-- Building Part: Mushroom Hut 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_MUSHROOM1",
	Name = "BUILDING_PART_TREEFOLK_MUSHROOM_NAME", 
	-- Category = "CORE", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_TREEFOLK_MUSHROOMHUT1" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.001" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.002" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.003" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.004" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.005" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.006" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.007" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.008" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.009" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.010" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.011" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.012" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.013" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.014" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.015" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.016" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.017" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.018" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.019" },
			{ BuildingPart = "BUILDING_PART_TREEFOLK_MUSHROOM_001", OptionalAttachNodeString = "Attach_Mushroom.020" },
		}
	},
	-- ConstructionVisual = "PREFAB_CONSTR_CHICKENYARD1",
    AssetBuildingFunction = "BUILDING_FUNCTION_TREEFOLK_MUSHROOM",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 2.5, {0.0, 0}, 12 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		},
	},
	Cost = {
        BuildRightTaxes = {	{ Resource = "WOOD", Quantity = 8 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 16 },
		}
    }
})



-- Building Function: Market: ASSIGNABLE -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_TREEFOLK_MARKET",
    AuthorizedFunctionList = "FUNCTION_LIST_TREEFOLK_MARKET"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "FUNCTION_LIST_TREEFOLK_MARKET",
    AssetFunctionList = {
        "BUILDING_FUNCTION_TREEFOLK_MARKET_MUSHROOM",
        "BUILDING_FUNCTION_TREEFOLK_MARKET_POULTRY",
        "BUILDING_FUNCTION_TREEFOLK_MARKET_EGG",
    }
})



-- Building Function: Market mushrooms -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_TREEFOLK_MARKET_MUSHROOM",
    Name = "BUILDING_FUNCTION_TREEFOLK_MARKET_MUSHROOM_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "MARKET_TENDER", 
        Behavior = "WORK_BEHAVIOR"
    },
    TypeList = { "RESOURCE_TYPE_MUSHROOM" }, 
    InputInventoryCapacity = {{ Resource = "RESOURCE_MUSHROOM", Quantity = 50 }}, -- these enable pseudo-production and collection of resources from non-warehouse locations
    ResourceListNeeded = {{ Resource = "RESOURCE_MUSHROOM", Quantity = 10 }}, -- these enable pseudo-production and collection of resources from non-warehouse locations
    ResourceProduced = {{ Resource = "RESOURCE_MUSHROOM", Quantity = 10 }}, -- these enable pseudo-production and collection of resources from non-warehouse locations

    IsOverrideCapacity = true, -- these enable selling
    CapacityPerSlot = 50 -- these enable selling
})



-- Building Function: Market poultry -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_TREEFOLK_MARKET_POULTRY",
    Name = "BUILDING_FUNCTION_TREEFOLK_MARKET_POULTRY_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "MARKET_TENDER", 
        Behavior = "WORK_BEHAVIOR"
    },
    TypeList = { "POULTRYFARM_POULTRY_RESOURCE_TYPE" }, 
    InputInventoryCapacity = {{ Resource = "RESOURCE_POULTRY", Quantity = 50 }}, -- these enable pseudo-production and collection of resources from non-warehouse locations
    ResourceListNeeded = {{ Resource = "RESOURCE_POULTRY", Quantity = 10 }}, -- these enable pseudo-production and collection of resources from non-warehouse locations
    ResourceProduced = {{ Resource = "RESOURCE_POULTRY_SELL", Quantity = 10 }}, -- these enable pseudo-production and collection of resources from non-warehouse locations

    IsOverrideCapacity = true, -- these enable selling
    CapacityPerSlot = 50 -- these enable selling
})



-- Building Function: Market eggs -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_TREEFOLK_MARKET_EGG",
    Name = "BUILDING_FUNCTION_TREEFOLK_MARKET_EGG_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "MARKET_TENDER", 
        Behavior = "WORK_BEHAVIOR"
    },
    TypeList = { "POULTRYFARM_EGG_RESOURCE_TYPE" }, 
    InputInventoryCapacity = {{ Resource = "BV1_EGG", Quantity = 50 }}, -- these enable pseudo-production and collection of resources from non-warehouse locations
    ResourceListNeeded = {{ Resource = "BV1_EGG", Quantity = 10 }}, -- these enable pseudo-production and collection of resources from non-warehouse locations
    ResourceProduced = {{ Resource = "RESOURCE_EGG_SELL", Quantity = 10 }}, -- these enable pseudo-production and collection of resources from non-warehouse locations

    IsOverrideCapacity = true, -- these enable selling
    CapacityPerSlot = 50 -- these enable selling
})



-- Building Part: Market 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_MARKET1",
	Name = "BUILDING_PART_TREEFOLK_MARKET_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_MARKET1"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {3.0, 2.8}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			},
		},
	},
    AssetBuildingFunction = "BUILDING_FUNCTION_TREEFOLK_MARKET",
	Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
		}
    }
})



-- Building Function: Wildfowl nests -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_TREEFOLK_NEST",
    Name = "BUILDING_PART_TREEFOLK_NEST_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_TREEFOLK_WILDFOWL", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
    ResourceProduced = {
		{ Resource = "BV1_EGG", Quantity = 1 },
	}
})



-- Building Part: Nest 1 -------------------------------------------------------------------------------------

-- End
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_NEST1END",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREEFOLK_NEST1END"
	},
	-- ConstructionVisual = "PREFAB_TREEFOLK_TREEHOUSE1END_CONSTR",
	Cost = {
        -- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 4 },
        --     { Resource = "PLANK", Quantity = 4 },
        --     { Resource = "STONE", Quantity = 4 },
		-- }
	}
})

-- Final
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TREEFOLK_NEST1",
	Name = "BUILDING_PART_TREEFOLK_NEST_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_TREEFOLK_TREE1ROOT",
		EndPart = "BUILDING_PART_TREEFOLK_NEST1END",
		FillerList = {
		    "BUILDING_PART_TREEFOLK_TREE1TILING",
    	},
		BasementFillerList = {
       	},
		MinimumScale = 0,
		IsVertical = true
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 1.6, {0, 0}, 16 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
	},
    AssetBuildingFunction = "BUILDING_FUNCTION_TREEFOLK_NEST",
	Cost = {
        BuildRightTaxes = {	{ Resource = "WOOD", Quantity = 8 } }
	}
})
